# $RCSfile: makedefs.mak,v $
# $Revision: 1.2 $ $Date: 2006/08/07 20:20:30 $
# Auth: David Loffredo (loffredo@steptools.com)
# 
# Copyright (c) 1991-2006 by STEP Tools Inc. 
# All Rights Reserved.
# 
# This file may be distributed and/or modified under the terms of 
# the GNU General Public License version 2 as published by the Free
# Software Foundation and appearing in the file LICENSE.GPL included
# with this file.
# 
# THIS FILE IS PROVIDED "AS IS" WITH NO WARRANTY OF ANY KIND,
# INCLUDING THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE.


#========================================
# USER RESERVED -- Reserved for users to set on the command line.
# Applications should not set these.  These variables are for C/C++
# compilation, Java compilation, FORTRAN compilation, and linking.
CFLAGS		=
FFLAGS		=
JFLAGS		=
LDFLAGS		=


# OPTIMIZE with the -O option.  Override from the command line for
# building debug versions.
#
OPTFLAGS	= -O

#========================================
# FILE EXTENSIONS.  Extensions and prefixes for different types of
# files change from platform to platform.  Hide these in macros so
# that we can more easily cut and paste between makefiles.

SHELL 		= /bin/sh

# Manualy set the suffixes ourselves.
SUFFIXES = \
	.exe .o .obj .c .cxx .cpp .cc .C \
	.y .Y .l .L .lex .f .F .r .s .sh .S .ln .h .p \
	.java .class .uil .uid

.SUFFIXES:
.SUFFIXES: $(SUFFIXES)

o		= .o
TMPLIB		= libtemp.a

# FILE TOOLS
AR 	= ar qv
CP	= cp
MKDIR 	= mkdir
MV	= mv
RANLIB	= ranlib
RM 	= rm -f
RMDIR 	= rm -rf
STRIP	= strip
UNZIP 	= unzip
ZIP 	= zip


#========================================
# C++ Compile and Link
# CXX is usually set if you are using gmake, but you can set it to
# other compilers if needed

CXX		= g++
#CXX		= CC

CXX_COMPILE	= $(CXX) -c  $(OPTFLAGS) $(CFLAGS) $(CXX_CFLAGS) $(CXX_SYSCFLAGS)
CXX_LINK	= $(CXX) $(LDFLAGS) $(CXX_LDFLAGS) $(CXX_SYSLDFLAGS)

CXX_CFLAGS 	= 
CXX_LDFLAGS	=

# System Flags -- Things for static linking or making sure that the
# compiler understands that a file is a C++ file or whatever.  These
# usually change from platform to platform.
CXX_SYSCFLAGS 	=
CXX_SYSLDFLAGS 	= 
CXX_SYSLIBS	= 


# Compilation Rules -- Repeat the rules for all of the different
# naming conventions.
#
.cxx.o:	; $(CXX_COMPILE) $<
.cpp.o:	; $(CXX_COMPILE) $<
.cc.o:	; $(CXX_COMPILE) $<
.C.o:	; $(CXX_COMPILE) $<

.cxx:	
	$(CXX_COMPILE) $<
	$(CXX_LINK) -o $@ $*.o $(LIBRARIES)
.cpp:	
	$(CXX_COMPILE) $<
	$(CXX_LINK) -o $@ $*.o $(LIBRARIES)
.cc:	
	$(CXX_COMPILE) $<
	$(CXX_LINK) -o $@ $*.o $(LIBRARIES)
.C:	
	$(CXX_COMPILE) $<
	$(CXX_LINK) -o $@ $*.o $(LIBRARIES)
