# $RCSfile: windefs.mak,v $
# $Revision: 1.1.1.1 $ $Date: 2006/07/24 21:57:01 $
# Auth: David Loffredo (loffredo@steptools.com)
# 
# Copyright (c) 1991-2006 by STEP Tools Inc. 
# All Rights Reserved.
# 
# This file may be distributed and/or modified under the terms of 
# the GNU General Public License version 2 as published by the Free
# Software Foundation and appearing in the file LICENSE.GPL included
# with this file.
# 
# THIS FILE IS PROVIDED "AS IS" WITH NO WARRANTY OF ANY KIND,
# INCLUDING THE WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE.


#========================================
# USER RESERVED -- Reserved for users to set on the command line.
# Applications should not set these.  These variables are for C/C++
# compilation, Java compilation, FORTRAN compilation, and linking.
CFLAGS		=
FFLAGS		=
JFLAGS		=
LDFLAGS		=


# OPTIMIZE for speed with /O2.  Show portability and other warnings
# with /W3.  Show potential 64bit problems with -Wp64.  Override this
# from the command line to build debug versions.
#
OPTFLAGS	= /O2 /W3

#========================================
# FILE EXTENSIONS.  The extensions and prefixes for different types of
# files change from platform to platform.  Hide these in macros so
# that we can more easily cut and paste between makefiles.

# Manualy set the suffixes ourselves.
SUFFIXES = \
	.exe .bat .o .obj .c .cxx .cpp .cc \
	.y .Y .l .L .f .r .s .sh .S .ln .h .p \
	.java .class

.SUFFIXES:
.SUFFIXES: $(SUFFIXES)

o = .obj

#========================================
# FILE TOOLS
#
# Removing files and directories differ on 9x and NT/2k/XP.  The 9x
# versions will sort of work, but the rmdir operation may fail.
#
!IF "$(OS)" == "Windows_NT"
RM 	= del /f/q
RMDIR 	= rmdir /s/q
NULL=
!ELSE
RM 	= echo y | del
RMDIR 	= deltree /Y
NULL=nul
!ENDIF

CP	= copy
MKDIR 	= mkdir
MV	= move
UNZIP 	= unzip
ZIP 	= zip


#========================================
# STATIC LIBRARY Build -- Under windows we use the lib tool, or link
# with the lib option to create static libraries.  Targets should use
# the /out option to specify the output file.
#
LIB32		= link.exe -lib
LIB32_SYSFLAGS	= /nologo

LINK		= link.exe


#========================================
# C++ Compile and Link
#
CXX		= cl
CXX_COMPILE	= $(CXX) /c $(OPTFLAGS) $(CFLAGS) $(CXX_CFLAGS) $(CXX_SYSCFLAGS)
CXX_LINK	= $(LINK) $(LDFLAGS) $(CXX_LDFLAGS) $(CXX_SYSLDFLAGS)


CXX_CFLAGS 	= 
CXX_LDFLAGS	=

# System things used for compilation.  Things for static linking or
# making sure that the compiler understands that a file is a C++ file
# or whatever.  These are the system flags always needed to compile,
# to link, and extra libraries for the end of the link line.
#
CXX_SYSCFLAGS 	= /nologo
CXX_SYSLDFLAGS 	= /nologo 
CXX_SYSLIBS	= kernel32.lib user32.lib advapi32.lib

# Compilation Rules -- Repeat the rules for all of the different
# naming conventions.  Note that .C would appear as .c on a case
# insensitive file system.
#
.cxx.obj:	; $(CXX_COMPILE) $<
.cpp.obj:	; $(CXX_COMPILE) $<
.cxx.exe:	
	$(CXX_COMPILE) $< 
	$(CXX_LINK) /out:$@ $*.obj $(LIBRARIES)

.cpp.exe:	
	$(CXX_COMPILE) $< 
	$(CXX_LINK) /out:$@ $*.obj $(LIBRARIES)

